; ##############################################################################
; ##############################################################################
; ##############################################################################
TIMER0_INITIALISIERUNG:
; TIMER0 (8Bit) Vorteiler													
;																			
; CS02 CS01 CS00 	Description												
;	0 	0 	0 		No clock source (Timer/Counter stopped).				
;	0 	0 	1 		clkI/O/		(No prescaling)								
;	0 	1 	0 		clkI/O/8 	(From prescaler)							
; *	0 	1 	1 		clkI/O/64 	(From prescaler)							
; 	1 	0 	0 		clkI/O/256 	(From prescaler)							
; 	1 	0 	1 		clkI/O/1024 (From prescaler)							
;	1 	1 	0 		External clock source on T0 pin. Clock on falling edge.	
;	1 	1 	1 		External clock source on T0 pin. Clock on rising edge.	
	ldi temp,(0<<CS02)|(1<<CS01)|(1<<CS00)
	OUT TCCR0,temp
; TIMER0 Startwert		
	ldi temp, TIMERWERT0
	out TCNT0,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TIMER1_INITIALISIERUNG:
;																			
; Timer1 (16Bit ) Vorteiler 												
;																			
; TCCR1B ==> ICNC1 ICES1 RESERVIERT WGM13 WGM12 CS12 CS11 CS10 				
;																			
;CS12 CS11 CS10 Description													
;	0	0 	0 	No clock source. (Timer/Counter stopped)					
;	0 	0 	1 	clkI/O/1    (No prescaling)									
;	0 	1 	0 	clkI/O/8    (From prescaler)								
;	0 	1 	1 	clkI/O/64   (From prescaler)								
;	1 	0 	0 	clkI/O/256  (From prescaler)								
; *	1 	0 	1 	clkI/O/1024 (From prescaler)								
;	1 	1 	0 	External clock source on T1 pin. Clock on falling edge.		
;	1 	1 	1 	External clock source on T1 pin. Clock on rising edge.		
;																			
	ldi temp,(1<<CS12)|(0<<CS11) |(1<<CS10)
	out TCCR1B,temp          
; Timer 1 Startwert 	
	ldi temp,HIGH(TIMERWERT1)
	out tcnt1H,temp         
	ldi temp,LOW (TIMERWERT1) 
	out tcnt1L,temp     
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TIMER2_INITIALISIERUNG:
; TIMER2 (8Bit) Vorteiler													
;																			
; TCCR2 ==> FOC2 WGM20 COM21 COM20 WGM21 CS22 CS21 CS20 					
; CS22 CS21 CS20 Description												
;	0	0 	0 	No clock source (Timer/Counter stopped).					
;	0 	0 	1 	clkT2S/		(No prescaling)									
; 	0 	1 	0 	clkT2S/8 	(From prescaler)								
;	0 	1 	1 	clkT2S/32 	(From prescaler)								
; *	1 	0 	0 	clkT2S/64 	(From prescaler)								
;	1 	0 	1 	clkT2S/128 	(From prescaler)								
;	1 	1 	0 	clkT2S/256 	(From prescaler)								
;	1 	1 	1 	clkT2S/1024 (From prescaler)								
	ldi temp,(1<<CS22)|(0<<CS21) |(0<<CS20)  
	out TCCR2,temp  
; TIMER2 Startwert		
	ldi temp, TIMERWERT2
	out TCNT2,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TIM0_OVF:
	push TEMP		    ; Sichern 			
	push TEMP1
	push TEMP2
	push TEMP3
	push TEMP4
	push TEMP5
	push TEMP6
	push TEMP7
	push TEMP8
	in	 TEMP,SREG		
	push TEMP	    	
; ----------------------------------
; TIMER0 Startwert					
	ldi temp, TIMERWERT0
	out TCNT0,temp
; ----------------------------------


; ----------------------------------
	pop	TEMP			; Wiederherstellen 
	out	SREG,TEMP		
	pop TEMP8
	pop TEMP7
	pop TEMP6
	pop TEMP5
	pop TEMP4
	pop TEMP3
	pop TEMP2
	pop TEMP1
	pop	TEMP	
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
; bei 16 MHz ==> 1s Takt														
TIM1_OVF:
	push TEMP		    ; Sichern 			
	push TEMP1
	push TEMP2
	push TEMP3
	push TEMP4
	push TEMP5
	push TEMP6
	push TEMP7
	push TEMP8
	in	 TEMP,SREG		
	push TEMP	    	
; ----------------------------------
; Timer Startwert	 				
	ldi temp,HIGH(TIMERWERT1)
	out tcnt1H,temp         
	ldi temp,LOW (TIMERWERT1) 
	out tcnt1L,temp
; ----------------------------------
	; PROGRAMM freigeben		 
	STS (adr_FREIGABE_PROGRAMM),EINS
; -------------------------------
	rcall ZEIT
	rcall ZEIT_BETRIEBSSTUNDEN

; ----------------------------------
	pop	TEMP			; Wiederherstellen 
	out	SREG,TEMP		
	pop TEMP8
	pop TEMP7
	pop TEMP6
	pop TEMP5
	pop TEMP4
	pop TEMP3
	pop TEMP2
	pop TEMP1
	pop	TEMP			
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
TIM2_OVF:
	push TEMP		    ; Sichern 			
	push TEMP1
	push TEMP2
	push TEMP3
	push TEMP4
	push TEMP5
	push TEMP6
	push TEMP7
	push TEMP8
	in	 TEMP,SREG		
	push TEMP	    	
; ----------------------------------
; TIMER2 Startwert		
	ldi temp, TIMERWERT2
	out TCNT2,temp
; ----------------------------------

; ----------------------------------
	pop	TEMP			; Wiederherstellen 
	out	SREG,TEMP		
	pop TEMP8
	pop TEMP7
	pop TEMP6
	pop TEMP5
	pop TEMP4
	pop TEMP3
	pop TEMP2
	pop TEMP1
	pop	TEMP
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
ZEIT:

	LDS temp,(adr_ss)	; aus SRAM laden	
	inc temp
	STS (adr_ss),temp	; in SRAM speichern	
	cpi temp,60
	brsh ZEIT_MM
	ret	
ZEIT_MM:
	clr temp
	STS (adr_ss),temp	; in SRAM speichern	
	LDS temp,(adr_mm)	; aus SRAM laden	
	inc temp
	STS (adr_mm),temp	; in SRAM speichern	
	cpi temp,60
	brsh ZEIT_HH
	ret	
ZEIT_HH:
	clr temp
	STS (adr_mm),temp	; in SRAM speichern	
	LDS temp,(adr_hh)	; aus SRAM laden	
	inc temp
	STS (adr_hh),temp	; in SRAM speichern	
	cpi temp,24
	brsh ZEIT_TAG
	ret	
ZEIT_TAG:
	clr temp
	STS (adr_hh),temp	; in SRAM speichern	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ZEIT_BETRIEBSSTUNDEN:
	LDS temp,(adr_BS_ss)
	inc temp
	STS (adr_BS_ss),temp
	cpi temp,60
	brsh ZEIT_BETRIEBSSTUNDEN_mm
	ret
ZEIT_BETRIEBSSTUNDEN_mm:
	STS (adr_BS_ss),NULL

	LDS temp,(adr_BS_mm)
	inc temp
	STS (adr_BS_mm),temp
	cpi temp,60
	brsh ZEIT_BETRIEBSSTUNDEN_hh
	ret
ZEIT_BETRIEBSSTUNDEN_hh:
	STS (adr_BS_mm),NULL

	LDS temp,(adr_BS_hh)
	inc temp
	STS (adr_BS_hh),temp
	cpi temp,24
	brsh ZEIT_BETRIEBSSTUNDEN_TAG
	ret
ZEIT_BETRIEBSSTUNDEN_TAG:
	STS (adr_BS_hh),NULL

	LDS ZL,(adr_BS_TAG_L)
	LDS ZH,(adr_BS_TAG_H)
	adiw ZL,1
	STS (adr_BS_TAG_L),ZL
	STS (adr_BS_TAG_H),ZH

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################