

;												
; Beispiel LCD164								
; Bernhard.Erfurt@gmx.de						
; 11/2006										
;												

;												
; Anschlussbelegung PINS						
;												
; PB0 ==> LCD									
; PB1 ==> LCD									
; PB2 ==> LCD									
; PB3 ==> LCD									
; PB4 ==> LCD									
; PB5 ==> LCD									
; PB6 ==> Quarz									
; PB7 ==> Quarz									
;												
; PC0 ==> ADC0									
; PC1 ==> 										
; PC2 ==> 										
; PC3 ==> 										
; PC4 ==> 										
; PC5 ==> 										
;												
; PD0 ==> 										
; PD1 ==> 										
; PD2 ==> 										
; PD3 ==> 										
; PD4 ==> 										
; PD5 ==> LED GRN								
; PD6 ==> LED GELB								
; PD7 ==> LED ROT								
;												


; ATmega8 										
.include "m8def.inc"

; KONSTANTEN									
.equ TAKT		=16000000			; 16 MHz	

; TIMER-WERTE					
.equ TIMERWERT0 =256-250			;(2 hoch 8  minus...)		bei 16MHz + Vorteiler   64 => 0.001s 	
.equ TIMERWERT1	=65536-15625		;(2 hoch 16 minus....15625) bei 16MHz + Vorteiler 1024 => 1s 		
.equ TIMERWERT2 =256-25				;(2 hoch 8  minus...)		bei 16MHz + Vorteiler   64 => 0.0001s 	


; USART							
.equ BAUD		=4800



; LEDS 											
.equ LED_D_GRUEN		= 5
.equ LED_D_GELB			= 6
.equ LED_D_ROT			= 7
; LCD								
.equ LCD_PORT				= PORTB
.equ LCD_D0					= 0
.equ LCD_D1					= 1
.equ LCD_D2					= 2
.equ LCD_D3					= 3
.equ LCD_RS					= 4
.equ LCD_E					= 5

; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN					= 0x0060			; 0x0060 START Adresse 		

.equ adr_FREIGABE_PROGRAMM		=0x0060+5

.equ adr_ss						=0x0060+10
.equ adr_mm						=0x0060+11
.equ adr_hh						=0x0060+12
.equ adr_TAG					=0x0060+13
.equ adr_MONAT					=0x0060+14
.equ adr_JAHR					=0x0060+15


.equ adr_BS_ss					=0x0060+20
.equ adr_BS_mm					=0x0060+21
.equ adr_BS_hh					=0x0060+22
.equ adr_BS_TAG_L				=0x0060+23
.equ adr_BS_TAG_H				=0x0060+24

.equ adr_ADC_0_L				=0x0060+50
.equ adr_ADC_0_H				=0x0060+51
.equ adr_ADC_1_L				=0x0060+52
.equ adr_ADC_1_H				=0x0060+53
.equ adr_ADC_2_L				=0x0060+54
.equ adr_ADC_2_H				=0x0060+55
.equ adr_ADC_3_L				=0x0060+56
.equ adr_ADC_3_H				=0x0060+57
.equ adr_ADC_4_L				=0x0060+58
.equ adr_ADC_4_H				=0x0060+59
.equ adr_ADC_5_L				=0x0060+60
.equ adr_ADC_5_H				=0x0060+61



; EEPROM-BELEGUNG ATmega8						
.equ adr_EEPROM_DATEN_0	= 0


; REGISTER										

.def NULL 	= R14
.def EINS 	= R15

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25





.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp TIM1_OVF   	  	; Timer1 Overflow Handler           					
rjmp INTERRUPT_ERROR	;rjmp TIM0_OVF   ; Timer0 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp ZEICHEN_EINLESEN 	; USART RX Complete Handler         					
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Bei unkorrekten Interrupt erfolgt RESET		
INTERRUPT_ERROR:
	wdr	
	cbi PORTD,LED_D_ROT		; LED ROT			
INTERRUPT_ERROR_SCHLEIFE:
	rjmp INTERRUPT_ERROR_SCHLEIFE

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp



; SRAM lschen										
SRAM_CLEAR:
	ldi ZL, LOW (adr_DATEN)
	ldi ZH, HIGH(adr_DATEN)
	clr temp
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND); Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND)	; Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	breq SRAM_CLEAR_w	; gleich  => SPRUNG	


; PORT B initialisieren								
	ldi temp, 0b11111111
	out DDRB, temp
; PORT B setzen										
	out PORTB, temp				
; PORT C initialisieren								
	ldi temp, 0b00000000
	out DDRC, temp
; PORT C setzen										
	out PORTC, temp				
; PORT D initialisieren								
	ldi temp, 0b11111111
	out DDRD, temp
; PORT D setzen										
	out PORTD, temp				

; Watchdog aktivieren (max. Zeit)					
	ldi TEMP,(1<<WDCE)|(1<<WDE)  
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR
			


;																			
; SLEEP+INT0+INT1 (externer Interrupt) konfigurieren						
;																			
; MCUCR => SE SM2 SM1 SM0 ISC11 ISC10 ISC01 ISC00 							
; SM2 SM1 SM0 Sleep Mode													
;*0   0   0   Idle															
; 0   0   1   ADC Noise Reduction											
; 0   1   0   Power-down													
; 0   1   1   Power-save													
; 1   0   0   Reserved														
; 1   0   1   Reserved														
; 1   1   0   Standby(1)													
;																			
;ISC11 ISC10 Description													
; 0 	0 	The low level of INT1 generates an interrupt request.			
; 0 	1 	Any logical change on INT1 generates an interrupt request.		
; 1 	0 	The falling edge of INT1 generates an interrupt request.		
; 1 	1 	The rising edge of INT1 generates an interrupt request.			
;																			
;ISC01 ISC00 Description													
; 0 	0 	The low level of INT0 generates an interrupt request.			
; 0 	1 	Any logical change on INT0 generates an interrupt request.		
; 1 	0 	The falling edge of INT0 generates an interrupt request.		
; 1 	1 	The rising  edge of INT0 generates an interrupt request.		
;																			
	ldi temp,(1<<SE)|(0<<SM2)|(0<<SM1)|(0<<SM0)|(1<<ISC11)|(0<<ISC10)|(1<<ISC01)|(0<<ISC00) 
	out MCUCR,temp
						
;																			
; INT0+INT1 (externer Interrupt)aktivieren									
;																			
; GICR => INT1 INT0 - - - - IVSEL IVCE 										
; General Interrupt Control													
;																			
	ldi temp, (0<<INT1)|(1<<INT0)|(0<<IVSEL)|(0<<IVCE)   
    out GICR, temp 


; TIMER0_INITIALISIERUNG							
	rcall TIMER0_INITIALISIERUNG
; TIMER1_INITIALISIERUNG							
	rcall TIMER1_INITIALISIERUNG
; TIMER2_INITIALISIERUNG							
	rcall TIMER2_INITIALISIERUNG
;																			
; Timer 0+1+2 berlauf-Int aktivieren (Timer/Counter Interrupt Mask)		
;																			
; TIMSK ==> OCIE2 TOIE2 TICIE1 OCIE1A OCIE1B TOIE1 R TOIE0  				
;																			
	ldi temp,(0<<OCIE2)|(0<<TOIE2)|(0<<TICIE1)|(0<<OCIE1A)|(0<<OCIE1B)|(1<<TOIE1)|(0<<TOIE0)
	out TIMSK,temp       

; ADC_INITIALISIERUNG								
	rcall ADC_INITIALISIERUNG
; USART_INITIALISIEREN								
	rcall USART_INITIALISIEREN	
; LCD_INITIALISIERUNG								
	rcall LCD_INITIALISIERUNG
; ANZEIGE_BEGRUESSUNG								
	rcall ANZEIGE_BEGRUESSUNG
; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; DATUM				
	STS(adr_TAG),  EINS			; in SRAM speichern		
	STS(adr_MONAT),EINS			; in SRAM speichern		
	STS(adr_JAHR), EINS			; in SRAM speichern		


	; BETRIEBSSTUNDEN	
	ldi temp,0
	STS(adr_BS_ss),temp			; in SRAM speichern		
	ldi temp,59
	STS(adr_BS_mm),temp			; in SRAM speichern		
	ldi temp,23
	STS(adr_BS_hh),temp			; in SRAM speichern		
	ldi temp,255
	STS(adr_BS_TAG_L),temp		; in SRAM speichern		
	ldi temp,255
	STS(adr_BS_TAG_H),temp		; in SRAM speichern		

; interrupts freigeben								
	sei

; ##############################################################################
; ##############################################################################
; ##############################################################################

; LED-TEST							
	rcall LED_TEST

; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR		; Watch-Dog-RESET	
	SLEEP
;-----------------------------------
	LDS temp,(adr_FREIGABE_PROGRAMM)
	tst temp
	breq LOOP
	STS(adr_FREIGABE_PROGRAMM),NULL
	WDR		; Watch-Dog-RESET		
;-----------------------------------
	cbi PORTD,LED_D_GRUEN	; GRN	
	cbi PORTD,LED_D_GELB	; GELB 	
	rcall MESSEN_0
	rcall MESSEN_1
	rcall MESSEN_2
	rcall MESSEN_3
	rcall MESSEN_4
	rcall MESSEN_5
	rcall KOMPLETTES_PROTOKOLL_SENDEN
	rcall PROGRAMM_CHECK
	rcall STEUERUNG_ANZEIGE
	sbi PORTD,LED_D_GELB	; GELB 	
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
STEUERUNG_ANZEIGE:

	ldi ZL,low (STEUERUNG_ANZEIGE_ADRESSE)
	ldi ZH,high(STEUERUNG_ANZEIGE_ADRESSE)
	; Sekunden addieren
	LDS temp,(adr_ss)
	add ZL,temp
	adc ZH,NULL
	IJMP

STEUERUNG_ANZEIGE_ADRESSE:
	rjmp ANZEIGE_BETRIEBSSTUNDEN
	rjmp ANZEIGE_BETRIEBSSTUNDEN
	rjmp ANZEIGE_BETRIEBSSTUNDEN
	rjmp ANZEIGE_BETRIEBSSTUNDEN
	rjmp ANZEIGE_BETRIEBSSTUNDEN
	rjmp ANZEIGE_BETRIEBSSTUNDEN
	rjmp ANZEIGE_BETRIEBSSTUNDEN
	rjmp ANZEIGE_BETRIEBSSTUNDEN
	rjmp ANZEIGE_BETRIEBSSTUNDEN
	rjmp ANZEIGE_BETRIEBSSTUNDEN

	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0


	rjmp ANZEIGE_BETRIEBSSTUNDEN
	rjmp ANZEIGE_BETRIEBSSTUNDEN
	rjmp ANZEIGE_BETRIEBSSTUNDEN
	rjmp ANZEIGE_BETRIEBSSTUNDEN
	rjmp ANZEIGE_BETRIEBSSTUNDEN
	rjmp ANZEIGE_BETRIEBSSTUNDEN
	rjmp ANZEIGE_BETRIEBSSTUNDEN
	rjmp ANZEIGE_BETRIEBSSTUNDEN
	rjmp ANZEIGE_BETRIEBSSTUNDEN
	rjmp ANZEIGE_BETRIEBSSTUNDEN


	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0


	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0


	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0
	rjmp ANZEIGE_SPANNUNG_0

; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "LCD_ADC.asm"
.include "LCD_INT.asm"
.include "LCD_LCD.asm"
.include "LCD_USART.asm"
.include "LCD_TIMER.asm"
.include "LCD_sonstiges.asm"

; ##############################################################################
; ##############################################################################
; ##############################################################################


TEXT_BEGRUESSUNG_1:
.db "LCD164 DEM0",0

TEXT_BEGRUESSUNG_2:
.db "PROGRAMM",0

TEXT_BEGRUESSUNG_3:
.db "ATmega8",0

TEXT_BEGRUESSUNG_4:
.db "19.November 2006",0

TEXT_BETRIEBSSTUNDEN:
.db "BETRIEBSSTUNDEN",0

TEXT_SPANNUNG:
.db "SPANNUNG",0

