; ##############################################################################
; ##############################################################################
; ##############################################################################
NEUSTART_MIT_WDR:
	WDR
	in temp, MCUCSR
	andi temp,0b00001000
	tst temp
	breq NEUSTART_MIT_WDR_FEHLER
	; MCUCSR clear		
	out MCUCSR,NULL
	ret
NEUSTART_MIT_WDR_FEHLER:
	cbi PORTD,LED_D_ROT		; LED ROT		
	rjmp NEUSTART_MIT_WDR_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	tst NULL
	brne PROGRAMM_CHECK_FEHLER
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_FEHLER
	ret
; SCHLEIFE, bis WDR zubeit		
PROGRAMM_CHECK_FEHLER:
	rjmp PROGRAMM_CHECK_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_TEST:
	cbi PORTD,LED_D_GRUEN	; GRN	
	rcall wait_1s
	cbi PORTD,LED_D_GELB	; GELB 	
	rcall wait_1s
	cbi PORTD,LED_D_ROT		; ROT	
	rcall wait_1s
	sbi PORTD,LED_D_GRUEN
	sbi PORTD,LED_D_GELB
	sbi PORTD,LED_D_ROT

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT:	ZL Adresse (low)										
;			ZH Adresse (High)										
;																	
; OUTPUT: 	TEMP (DATEN)											
;																	
; rcall EEPROM_READ_PLUS ; INP: ZL+ZH(ADRESSE) OUT: TEMP (DATEN)	
;																	
EEPROM_READ_PLUS:
	sbic EECR,EEWE 		; Wait for completion of previous write
	rjmp EEPROM_READ_PLUS
	out  EEARH, ZH		; ADRESSE setzen						
	out  EEARL, ZL
	sbi  EECR,EERE		; Start eeprom read by writing EERE		
	in 	 temp,EEDR		; Read data from data register			
	adiw ZL,1			; ADRESSE +1 							
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT:	ZL Adresse (low)										
;			ZH Adresse (High)										
;																	
; 		 	TEMP  DATEN												
;																	
;	rcall EEPROM_WRITE_PLUS	; INP: TEMP(DATEN) ZL+ZH(ADRESSE) (Z+1)	
;																	
EEPROM_WRITE_PLUS:
	sbic EECR,EEWE		; Wait for completion of previous write
	rjmp EEPROM_WRITE_PLUS
	out  EEARH,ZH		; ADRESSE setzen						
	out  EEARL,ZL
	out  EEDR, temp		; Write data  to data register			
	sbi  EECR, EEMWE	; Write logical one to EEMWE			
	sbi  EECR, EEWE		; Start eeprom write by setting EEWE	
	adiw ZL,1			; ADRESSE +1 							
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;Pause nach jeder bertragung;50us Pause
wait50us:                              
           	ldi  temp, 255
wait50us_: 
			dec  temp
           	brne wait50us_
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;Lngere Pause fr manche Befehle;5ms Pause
wait5ms:                               
	push temp1           ; temp1 auf dem Stack sichern            
	push temp2           ; temp2 auf dem Stack sichern            
;------------
        ldi temp1,110
	   	clr temp2

wait5ms_:
   		wdr				; WATCH-DOG	
		dec  temp2
        brne wait5ms_
        dec  temp1
        brne wait5ms_
;------------
	pop temp2      		; temp2 wiederherstellen                    
	pop temp1      		; temp1 wiederherstellen                    
ret

; ##############################################################################
; ##############################################################################
; ##############################################################################
; bei 16 MHz Takt ca. 0,1s Pause												
WAIT_100ms:
	push temp1          ; temp1 auf dem Stack sichern            
	push temp2          ; temp2 auf dem Stack sichern            
	push temp3          ; temp3 auf dem Stack sichern            

;------------
	ldi	temp3,6			;(6 bei 16MHz)			
	clr temp2
	clr	temp1			
WAIT_100ms_w:	
	wdr
	dec	 temp1
	brne WAIT_100ms_w
	dec	 temp2		
	brne WAIT_100ms_w
	dec	 temp3
	brne WAIT_100ms_w
;------------
	pop temp3      		; temp3 wiederherstellen                    
	pop temp2      		; temp2 wiederherstellen                    
	pop temp1      		; temp1 wiederherstellen                    
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; bei 16 MHz Takt ca.1s Pause													
WAIT_1s:
	push temp1          ; temp1 auf dem Stack sichern            
	push temp2          ; temp2 auf dem Stack sichern            
	push temp3          ; temp3 auf dem Stack sichern            

;------------
	ldi	temp3,60		;(60 bei 16MHz)			
	clr temp2
	clr	temp1			
wait1s_w:	
	wdr
	dec	temp1
	brne	wait1s_w
	dec	temp2		
	brne	wait1s_w
	dec	temp3
	brne	wait1s_w
;------------
	pop temp3      		; temp3 wiederherstellen                    
	pop temp2      		; temp2 wiederherstellen                    
	pop temp1      		; temp1 wiederherstellen                    
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################